#include <gl/gl.h>
#include <gl/glu.h>
#include <windows.h>

#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include "winreg.h"
#include "tchar.h"


#include "hbapifs.h"


HB_FUNC( INITGLWINDOW )
{
    PIXELFORMATDESCRIPTOR pfd;
    int iFormat;
   	HDC hDC;
	HGLRC hRC;
	HWND hWnd;
	
	hWnd = (HWND) hb_parnl( 1 );

	// get the device context (DC)
    hDC = GetDC( hWnd  );

    // set the pixel format for the DC
    ZeroMemory( &pfd, sizeof( pfd ) );
    pfd.nSize = sizeof( pfd );
    pfd.nVersion = 1;
    pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL |
                  PFD_DOUBLEBUFFER;
    pfd.iPixelType = PFD_TYPE_RGBA;
    pfd.cColorBits = 24;
    pfd.cDepthBits = 16;
    pfd.iLayerType = PFD_MAIN_PLANE;
    iFormat = ChoosePixelFormat( hDC, &pfd );
    SetPixelFormat( hDC, iFormat, &pfd );

    // create and enable the render context (RC)
    hRC = wglCreateContext( hDC );
    wglMakeCurrent( hDC, hRC );
}

HB_FUNC( RELEASEGLWINDOW )
{
   	HDC hDC;
	HGLRC hRC;
	
    hRC = wglGetCurrentContext();
    hDC = wglGetCurrentDC();
	
	wglMakeCurrent( NULL, NULL );
	wglDeleteContext( hRC );
	ReleaseDC( (HWND) hb_parnl( 1 ), hDC );
	
}

HB_FUNC( GLDRAWTRIANGLE )
{
   glBegin( GL_TRIANGLES );
   glColor3f( 1.0f, 0.0f, 0.0f ); glVertex2f( hb_parnl(1), hb_parnl(2) );
   glColor3f( 0.0f, 1.0f, 0.0f ); glVertex2f( hb_parnl(3), hb_parnl(4) );
   glColor3f( 0.0f, 0.0f, 1.0f ); glVertex2f( hb_parnl(5), hb_parnl(6) );
   glEnd();
		
}


HB_FUNC( SHOWGRAPHICS )

{
   SwapBuffers( wglGetCurrentDC() );
}
